#!/usr/bin/env python

from scgi.quixote_handler import QuixoteHandler, main
from quixote.publish import Publisher
from pyPgSQL import PgSQL
import xmlrpclib

from quixote import enable_ptl
enable_ptl()

# Warning: Must import SOAPpy *after* enable_ptl.  I don't know why.
from SOAPpy import SOAPProxy


import connection_args
CONNECTION_ARGS = connection_args.connection_args
##CONNECT_ARGS_FILE = 'connection_args.txt'

DEBUG = 0

def dbgmsg(*args):
    if DEBUG:
        for arg in args:
            print arg,
        print


#
# A container for persistent connections etc.
#
class PersistentContainer:
    pass


class MyPublisher(Publisher):
    def __init__(self, root_namespace, config=None):
        Publisher.__init__(self, root_namespace, config)
        self.container = PersistentContainer()
##        connectionFile = file(CONNECT_ARGS_FILE, 'r')
##        connectionArgs = connectionFile.read().strip()
##        connectionFile.close()
##        self.container.dbConnection = PgSQL.connect(connectionArgs)
        self.container.dbConnection = PgSQL.connect(**CONNECTION_ARGS)
        self.container.xmlrpcProxy = xmlrpclib.ServerProxy('http://localhost:8082')
        self.container.soapProxy = SOAPProxy(str("http://localhost:8083/"))
        meerkatURI = "http://www.oreillynet.com/meerkat/xml-rpc/server.php"
        self.container.meerkatServer = xmlrpclib.Server(meerkatURI)
        dbgmsg('1a. (MyPublisher.__init__) created dbConnection:', self.container.dbConnection)
        dbgmsg('1b. (MyPublisher.__init__) created XML-RPC proxy:', self.container.xmlrpcProxy)
        dbgmsg('1c. (MyPublisher.__init__) created SOAP proxy:', self.container.soapProxy)
        dbgmsg('1d. (MyPublisher.__init__) created Meerkat server:', self.container.meerkatServer)

    def __del__(self):
        self.container.dbConnection.close()
        print '3. (MyPublisher.__del__) closed dbConnection:', self.container.dbConnection

    def start_request(self, request):
        Publisher.start_request(self, request)
        request.container = self.container
        dbgmsg('2a. (MyPublisher.start_request) Passing db con:', self.container.dbConnection)
        dbgmsg('2b. (MyPublisher.start_request) Passing XML-RPC proxy:', self.container.xmlrpcProxy)
        dbgmsg('2c. (MyPublisher.start_request) Passing SOAP proxy:', self.container.soapProxy)
        dbgmsg('2d. (MyPublisher.start_request) Passing Meerkat server:', self.container.meerkatServer)


class MyAppHandler(QuixoteHandler):
    publisher_class = MyPublisher
    root_namespace = "skeleton.ui"
    prefix = ""


if __name__ == '__main__':
    main(MyAppHandler)

