#!/usr/bin/env python
"""SOAP server to provide an example for test2.
"""


from SOAPpy import SOAPServer


class Functions:
    """Publish test methods."""

    def double(self, inval):
        outval = inval * 2
        print '(double) %d --> %d' % (inval, outval)
        return outval

    def concatenate(self, instr1, instr2):
        s1 = '[[%s||%s]]' % (instr1, instr2)
        print '(concatenate) %s + %s --> %s' % (instr1, instr2, s1)
        return s1

    def structures(self, indict):
##        print '(structures) indict: %s' % str(indict)
        # Note: Can't use indict.get(), because it is actually an instance
        #   of SOAPpy.Types.structType.
        try:
            arg1 = indict[u'arg1']
        except KeyError:
            arg1 = 'AAAA'
        try:
            arg2 = indict[u'arg2']
        except KeyError:
            arg2 = 'BBBB'
        outarg1 = '**%s**' % arg1
        outarg2 = '**%s**' % arg2
        outval = [outarg1, outarg2]
        print '(structures) arg1: %s  arg2: %s  outval: %s' % (arg1, arg2, outval)
        return outval


if __name__ == '__main__':
    print 'Serving SOAP class Funcitons on port 8083.'
    server = SOAPServer(("localhost", 8083))
    functions = Functions()
    server.registerObject(functions)
    server.serve_forever()
